#include <stdio.h>
#include <string.h>

int solution(char*** clothes, int clothesRowSize) {
    int comb[30] = {0};
    for (int i = 0; i < clothesRowSize; i++) {
        int found = 0;
        for (int j = 0; j < 30; j++) {
            if (comb[j] == 0) {
                comb[j] = 2;
                found = 1;
                break;
            } else if (strcmp(clothes[i][1], clothes[j - 1][1]) == 0) {
                comb[j]++;
                found = 1;
                break;
            }
        }
        if (!found) {
            comb[clothesRowSize] = 2;
        }
    }

    int result = 1;
    for (int i = 0; i < 30; i++) {
        if (comb[i] == 0) {
            break;
        }
        result *= comb[i];
    }

    return result - 1;
}
