#include <stdio.h>
#include <string.h>

int solution(char* spell, char** dic, int dicSize) {
    int spell_set[26] = {0};
    for (int i = 0; i < strlen(spell); i++) {
        spell_set[spell[i] - 'a'] = 1;
    }

    for (int i = 0; i < dicSize; i++) {
        int word_set[26] = {0};
        for (int j = 0; j < strlen(dic[i]); j++) {
            word_set[dic[i][j] - 'a'] = 1;
        }

        int found = 1;
        for (int j = 0; j < 26; j++) {
            if (spell_set[j] != word_set[j]) {
                found = 0;
                break;
            }
        }
        if (found) {
            return 1;
        }
    }

    return 2;
}
