#include <stdio.h>
#include <stdlib.h>

int* solution(int* answers, int length, int* returnSize) {
    int answer_types[3][10] = {
        {1, 2, 3, 4, 5},
        {2, 1, 2, 3, 2, 4, 2, 5},
        {3, 3, 1, 1, 2, 2, 4, 4, 5, 5}
    };
    int answer_types_length[3] = {5, 8, 10};

    int scores[3] = {0};
    for (int type_idx = 0; type_idx < 3; type_idx++) {
        for (int idx = 0; idx < length; idx++) {
            if (answers[idx] == answer_types[type_idx][idx % answer_types_length[type_idx]]) {
                scores[type_idx]++;
            }
        }
    }

    int max_score = scores[0];
    for (int i = 1; i < 3; i++) {
        if (scores[i] > max_score) {
            max_score = scores[i];
        }
    }

    int* result = (int*)malloc(3 * sizeof(int));
    *returnSize = 0;
    for (int idx = 0; idx < 3; idx++) {
        if (scores[idx] == max_score) {
            result[(*returnSize)++] = idx + 1;
        }
    }

    return result;
}
