#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

int* solution(char** wall, int wallRowSize, int wallColSize) {
    int* result = (int*)malloc(4 * sizeof(int));
    int min_x = INT_MAX;
    int min_y = INT_MAX;
    int max_x = INT_MIN;
    int max_y = INT_MIN;
    for (int i = 0; i < wallRowSize; i++) {
        for (int j = 0; j < wallColSize; j++) {
            if (wall[i][j] == '#') {
                if (i < min_x) min_x = i;
                if (j < min_y) min_y = j;
                if (i > max_x) max_x = i;
                if (j > max_y) max_y = j;
            }
        }
    }
    result[0] = min_x;
    result[1] = min_y;
    result[2] = max_x + 1;
    result[3] = max_y + 1;
    return result;
}
