#include <stdlib.h>
#include <string.h>

int cmp(const void *a, const void *b) {
    return strcmp(*(char **)a, *(char **)b);
}

char **solution(char ***tickets, int tickets_len, int *result_len) {
    char **routes[10000];
    int routes_len[10000] = {0};
    for (int i = 0; i < tickets_len; i++) {
        char **ticket = tickets[i];
        char *key = ticket[0];
        char *value = ticket[1];
        int key_idx = -1;
        for (int j = 0; j < 10000; j++) {
            if (routes[j] == NULL || strcmp(routes[j][0], key) == 0) {
                key_idx = j;
                break;
            }
        }
        if (routes[key_idx] == NULL) {
            routes[key_idx] = malloc(10000 * sizeof(char *));
            routes[key_idx][0] = key;
        }
        routes[key_idx][++routes_len[key_idx]] = value;
    }

    for (int i = 0; i < 10000; i++) {
        if (routes[i] != NULL) {
            qsort(routes[i] + 1, routes_len[i], sizeof(char *), cmp);
        }
    }

    char *stack[10000];
    int top = -1;
    stack[++top] = "ICN";
    char **path = malloc(10000 * sizeof(char *));
    while (top >= 0) {
        char *topS = stack[top];
        int topS_idx = -1;
        for (int i = 0; i < 10000; i++) {
            if (routes[i] != NULL && strcmp(routes[i][0], topS) == 0) {
                topS_idx = i;
                break;
            }
        }
        if (topS_idx == -1 || routes_len[topS_idx] == 0) {
            path[(*result_len)++] = stack[top--];
        } else {
            stack[++top] = routes[topS_idx][routes_len[topS_idx]--];
        }
    }

    for (int i = 0; i < *result_len / 2; i++) {
        char *temp = path[i];
        path[i] = path[*result_len - i - 1];
        path[*result_len - i - 1] = temp;
    }

    return path;
}
