int solution(int n, int **computers) {
    int visited[200] = {0};
    int networks = 0;

    for (int node = 0; node < n; node++) {
        if (!visited[node]) {
            int stack[10000];
            int top = -1;
            stack[++top] = node;
            visited[node] = 1;

            while (top >= 0) {
                int curr = stack[top--];

                for (int next_node = 0; next_node < n; next_node++) {
                    if (!visited[next_node] && computers[curr][next_node] == 1) {
                        visited[next_node] = 1;
                        stack[++top] = next_node;
                    }
                }
            }

            networks++;
        }
    }

    return networks;
}
