#include <stdio.h>
#include <stdlib.h>

typedef struct {
    int i;
    int j;
    int k;
} Command;

int cmp(const void *a, const void *b) {
    return *(int *)a - *(int *)b;
}

int *solution(int *array, int array_len, Command *commands, int commands_len) {
    int *result = (int *)malloc(commands_len * sizeof(int));
    for (int i = 0; i < commands_len; i++) {
        Command command = commands[i];
        int i_ = command.i - 1;
        int j_ = command.j - 1;
        int k_ = command.k - 1;

        int temp[j_ - i_ + 1];
        for (int j = i_; j <= j_; j++) {
            temp[j - i_] = array[j];
        }
        qsort(temp, j_ - i_ + 1, sizeof(int), cmp);
        result[i] = temp[k_];
    }
    return result;
}
