#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

int solution(int n, int lost[], int lostSize, int reserve[], int reserveSize) {
    bool *lostSet = malloc((n + 1) * sizeof(bool));
    bool *reserveSet = malloc((n + 1) * sizeof(bool));
    for (int i = 0; i <= n; i++) {
        lostSet[i] = false;
        reserveSet[i] = false;
    }
    for (int i = 0; i < lostSize; i++) {
        lostSet[lost[i]] = true;
    }
    for (int i = 0; i < reserveSize; i++) {
        reserveSet[reserve[i]] = true;
    }

    for (int i = 1; i <= n; i++) {
        if (reserveSet[i] && lostSet[i]) {
            reserveSet[i] = false;
            lostSet[i] = false;
        }
    }

    for (int res = 1; res <= n; res++) {
        if (reserveSet[res]) {
            if (res - 1 >= 1 && lostSet[res - 1]) {
                lostSet[res - 1] = false;
            } else if (res + 1 <= n && lostSet[res + 1]) {
                lostSet[res + 1] = false;
            }
        }
    }

    int count = 0;
    for (int i = 1; i <= n; i++) {
        if (lostSet[i]) {
            count++;
        }
    }

    return n - count;
}
