#include <stdio.h>
#include <stdlib.h>

int max(int a, int b) {
    return a > b ? a : b;
}

int solution(int **triangle, int size) {
    int *pre = triangle[0];
    for (int i = 1; i < size; i++) {
        int *step = triangle[i];
        for (int j = 0; j <= i; j++) {
            if (j == 0) {
                step[j] += pre[j];
            } else if (j == i) {
                step[j] += pre[j - 1];
            } else {
                step[j] += max(pre[j - 1], pre[j]);
            }
        }
        pre = step;
    }

    int result = 0;
    for (int i = 0; i < size; i++) {
        result = max(result, pre[i]);
    }

    return result;
}
