#include <stdlib.h>
#include <string.h>

int cmp(const void *a, const void *b) {
    return *(char *)a - *(char *)b;
}

int solution(char *before, char *after) {
    int before_len = strlen(before);
    int after_len = strlen(after);

    if (before_len != after_len) {
        return 0;
    }

    char before_sorted[10000];
    strcpy(before_sorted, before);
    qsort(before_sorted, before_len, sizeof(char), cmp);

    char after_sorted[10000];
    strcpy(after_sorted, after);
    qsort(after_sorted, after_len, sizeof(char), cmp);

    return strcmp(before_sorted, after_sorted) == 0 ? 1 : 0;
}
