#include <stdlib.h>

typedef struct {
    int key;
    int value[10000];
    int value_len;
} Item;

int cmp(const void *a, const void *b) {
    return ((Item *)b)->key - ((Item *)a)->key;
}

int *solution(int **score, int score_len) {
    Item ranks[10000];
    int ranks_len = 0;
    for (int i = 0; i < score_len; i++) {
        int *student = score[i];
        int sum = 0;
        for (int j = 0; j < score_len; j++) {
            sum += student[j];
        }

        int key_idx = -1;
        for (int j = 0; j < ranks_len; j++) {
            if (ranks[j].key == sum) {
                key_idx = j;
                break;
            }
        }
        if (key_idx == -1) {
            key_idx = ranks_len++;
            ranks[key_idx].key = sum;
            ranks[key_idx].value_len = 0;
        }
        ranks[key_idx].value[ranks[key_idx].value_len++] = i;
    }

    qsort(ranks, ranks_len, sizeof(Item), cmp);

    int *result = malloc(score_len * sizeof(int));
    int rank = 1;
    for (int i = 0; i < ranks_len; i++) {
        Item item = ranks[i];
        for (int j = 0; j < item.value_len; j++) {
            result[item.value[j]] = rank;
        }
        rank += item.value_len;
    }

    return result;
}
