#include <stdio.h>
#include <stdlib.h>

int compare(const void *a, const void *b) {
    int arg1 = *(const int *)a;
    int arg2 = *(const int *)b;
    return (arg1 > arg2) - (arg1 < arg2);
}

int *solution(int emergency[], int size) {
    int *patients = malloc(size * sizeof(int));
    for (int i = 0; i < size; i++) {
        patients[i] = -emergency[i];
    }
    qsort(patients, size, sizeof(int), compare);

    int *orders = malloc(size * sizeof(int));
    for (int i = 0; i < size; i++) {
        orders[i] = 0;
    }
    for (int i = 0; i < size; i++) {
        orders[i] = i + 1;
    }

    return orders;
}
