import java.util.HashMap;

public class Solution {
    public static int solution(String[][] clothes) {
        HashMap<String, Integer> comb = new HashMap<>();
        for (String[] cloth : clothes) {
            String category = cloth[1];
            comb.put(category, comb.getOrDefault(category, 0) + 1);
        }

        int result = 1;
        for (int count : comb.values()) {
            result *= count + 1;
        }

        return result - 1;
    }
}
