import java.util.*;

class Solution {
    public static int[] solution(String[] id_list, String[] report, int k) {
        Map<String,List<String>> reports = new HashMap<>();
        Map<String,Integer> counts = new HashMap<>();

        for (String repo : new HashSet<>(Arrays.asList(report))) {
            String[] splitRepo = repo.split(" ");
            String reporter = splitRepo[0];
            String reported = splitRepo[1];
            if (!reports.containsKey(reporter)) {
                reports.put(reporter,new ArrayList<>());
            }
            reports.get(reporter).add(reported);
            counts.put(reported,counts.getOrDefault(reported,0)+1);
        }

        int[] result = new int[id_list.length];
        for (int idx=0; idx<id_list.length; idx++) {
            String id=id_list[idx];
            if (reports.containsKey(id)) {
                for (String reported : reports.get(id)) {
                    if (counts.get(reported)>=k) {
                        result[idx]++;
                    }
                }
            }
        }

        return result;
    }
}
