import java.util.*;

public class Solution {
    public static int[] solution(int[] progresses, int[] speeds) {
        List<Integer> answerList = new ArrayList<>();
        int time = 0;
        int count = 0;
        int idx = 0;
        while (idx < progresses.length) {
            if (progresses[idx] + time * speeds[idx] >= 100) {
                idx++;
                count++;
            } else {
                if (count > 0) {
                    answerList.add(count);
                    count = 0;
                }
                time++;
            }
        }
        answerList.add(count);
        int[] answer = new int[answerList.size()];
        for (int i = 0; i < answerList.size(); i++) {
            answer[i] = answerList.get(i);
        }
        return answer;
    }
}
