import java.util.ArrayList;

public class Solution {
    public static int[] solution(int[] answers) {
        int[][] answer_types = {
            {1, 2, 3, 4, 5},
            {2, 1, 2, 3, 2, 4, 2, 5},
            {3, 3, 1, 1, 2, 2, 4, 4, 5, 5}
        };

        int[] scores = new int[3];
        for (int type_idx = 0; type_idx < answer_types.length; type_idx++) {
            for (int idx = 0; idx < answers.length; idx++) {
                if (answers[idx] == answer_types[type_idx][idx % answer_types[type_idx].length]) {
                    scores[type_idx]++;
                }
            }
        }

        int max_score = scores[0];
        for (int score : scores) {
            if (score > max_score) {
                max_score = score;
            }
        }

        ArrayList<Integer> result_list = new ArrayList<>();
        for (int idx = 0; idx < scores.length; idx++) {
            if (scores[idx] == max_score) {
                result_list.add(idx +1);
            }
        }

        int[] result = new int[result_list.size()];
        for (int i =0; i<result_list.size(); i++){
            result[i]=result_list.get(i);
        }
        
        return result;
    }
}
