import java.util.*;

public class Solution {
    public static int solution(int[] scoville, int K) {
        int numFoods = scoville.length;
        Queue<Integer> queue = new PriorityQueue<>();
        for (int sco : scoville) {
            queue.add(sco);
        }
        int score = queue.poll();

        int idx = 0;
        while (idx < numFoods - 1 && score < K) {
            queue.add(score + queue.poll() * 2);
            score = queue.poll();
            idx++;
        }

        return score < K ? -1 : idx;
    }
}
