import java.util.*;

public class Solution {
    public static long solution(int n, int[] works) {
        Queue<Integer> queue = new PriorityQueue<>();
        for (int work : works) {
            queue.add(-work);
        }

        for (int i = 0; i < n; i++) {
            int work = queue.poll();
            if (work == 0) {
                queue.add(work);
                break;
            }
            queue.add(work + 1);
        }

        long result = 0;
        for (int work : queue) {
            result += (long)work * work;
        }
        return result;
    }
}
