import java.util.HashSet;

public class Solution {
    public static int solution(int N, int number) {
        HashSet<Integer>[] memo = new HashSet[8];
        for (int i = 0; i < memo.length; i++) {
            memo[i] = new HashSet<>();
        }

        for (int i = 1; i <= 8; i++) {
            int num = Integer.parseInt(Integer.toString(N).repeat(i));
            memo[i - 1].add(num);

            for (int j = 0; j < i - 1; j++) {
                for (int x : memo[j]) {
                    for (int y : memo[i - j - 2]) {
                        memo[i - 1].add(x + y);
                        memo[i - 1].add(x - y);
                        memo[i - 1].add(x * y);
                        if (y != 0) {
                            memo[i - 1].add(x / y);
                        }
                    }
                }
            }

            if (memo[i - 1].contains(number)) {
                return i;
            }
        }

        return -1;
    }
}
