import java.util.*;

public class Solution {
    public static String solution(String X, String Y) {
        final var x = new int[10];
        for (final var c : X.toCharArray()) {
            x[c - '0']++;
        }

        final var y = new int[10];
        for (final var c : Y.toCharArray()) {
            y[c - '0']++;
        }

        final var common = new int[10];
        for (int i = 0; i < 10; i++) {
            common[i] = Math.min(x[i], y[i]);
        }

        final var stringBuilder = new StringBuilder();
        for (int key = 9; key >= 0; key--) {
            final var value = common[key];
            for (int j = 0; j < value; j++) {
                stringBuilder.append(key);
            }
        }

        final var number = stringBuilder.toString();
        if (number.startsWith("0")) {
            return "0";
        } else if (number.isEmpty()) {
            return "-1";
        } else {
            return number;
        }
    }
}
