import java.util.*;

public class Solution {
    public static int[] solution(int[][] score) {
        final var ranks = new TreeMap<Integer,List<Integer>>(Comparator.reverseOrder());
        for (int idx = 0; idx < score.length; idx++) {
            final var student = score[idx];
            final var sum = Arrays.stream(student).sum();

            if (!ranks.containsKey(sum)) {
                ranks.put(sum,new ArrayList<>());
            }
            ranks.get(sum).add(idx);
        }

        final var result = new int[score.length];
        var rank = 1;
        for (final var indices : ranks.values()) {
            for (final var index : indices) {
                result[index] = rank;
            }

            rank += indices.size();
        }

        return result;
    }
}
