import java.util.HashSet;

public class Solution {
    public static int solution(int[][] board) {
        int n = board.length;
        HashSet<Integer> danger = new HashSet<>();
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (board[i][j] == 1) {
                    for (int di = -1; di <= 1; di++) {
                        for (int dj = -1; dj <= 1; dj++) {
                            if (0 <= i + di && i + di < n && 0 <= j + dj && j + dj < n) {
                                danger.add((i + di) * n + j + dj);
                            }
                        }
                    }
                }
            }
        }

        return n * n - danger.size();
    }
}
