import java.util.HashSet;

public class Solution {
    public static int inclination(int[] point1, int[] point2) {
        return (point2[1] - point1[1]) / (point2[0] - point1[0]);
    }

    public static int solution(int[][] dots) {
        HashSet<Integer> inclinations = new HashSet<>();
        for (int i = 0; i < dots.length; i++) {
            for (int j = i + 1; j < dots.length; j++) {
                inclinations.add(inclination(dots[i], dots[j]));
            }
        }

        return inclinations.size() == 1 ? 1 : 0;
    }
}
