import java.util.ArrayList;

public class Solution {
    public static int to_days(String date) {
        String[] splitDate = date.split("\\.");
        int year = Integer.parseInt(splitDate[0]);
        int month = Integer.parseInt(splitDate[1]);
        int day = Integer.parseInt(splitDate[2]);
        return year * 28 * 12 + month * 28 + day;
    }

    public static int[] solution(String today, String[] terms, String[] privacies) {
        int[] months = new int[26];
        for (String term : terms) {
            months[term.charAt(0) - 'A'] = Integer.parseInt(term.substring(2)) * 28;
        }

        int today_days = to_days(today);
        ArrayList<Integer> expireList = new ArrayList<>();
        for (int i = 0; i < privacies.length; i++) {
            String[] splitPrivacy = privacies[i].split(" ");
            if (to_days(splitPrivacy[0]) + months[splitPrivacy[1].charAt(0) - 'A'] <= today_days) {
                expireList.add(i + 1);
            }
        }

        return expireList.stream().mapToInt(i -> i).toArray();
    }
}
