#include <stdio.h>
#include <string.h>

char* solution(char* s, char* skip, int index) {
    int a_to_z[26] = {0};
    for (int i = 0; i < strlen(skip); i++) {
        a_to_z[skip[i] - 'a'] = 1;
    }

    int l = 0;
    for (int i = 0; i < 26; i++) {
        if (a_to_z[i] == 0) {
            a_to_z[l++] = i + 'a';
        }
    }

    int dic_alpha[26];
    for (int i = 0; i < l; i++) {
        dic_alpha[a_to_z[i] - 'a'] = i;
    }

    char* result = (char*)malloc((strlen(s) + 1) * sizeof(char));
    for (int i = 0; i < strlen(s); i++) {
        result[i] = a_to_z[(dic_alpha[s[i] - 'a'] + index) % l];
    }
    result[strlen(s)] = '\0';
    return result;
}
