#include <stdbool.h>
#include <string.h>

bool solution(char *s) {
    int stack[1000];
    int top = -1;
    for (int i = 0; i < strlen(s); i++) {
        char charS = s[i];
        if (charS == '(') {
            stack[++top] = charS;
        } else if (charS == ')') {
            if (top < 0) {
                return false;
            }
            top--;
        }
    }
    return top == -1;
}
