#include <stdbool.h>

typedef struct {
    int index;
    int priority;
} Item;

int solution(int *priorities, int priorities_len, int location) {
    Item queue[1000];
    for (int i = 0; i < priorities_len; i++) {
        queue[i].index = i;
        queue[i].priority = priorities[i];
    }
    int order = 0;
    int head = 0;
    int tail = priorities_len;
    while (head < tail) {
        Item cur = queue[head++];
        bool any_greater = false;
        for (int i = head; i < tail; i++) {
            if (cur.priority < queue[i].priority) {
                any_greater = true;
                break;
            }
        }
        if (any_greater) {
            queue[tail++] = cur;
        } else {
            order++;
            if (cur.index == location) {
                return order;
            }
        }
    }
    return -1;
}
