#include <stdio.h>
#include <string.h>

char* solution(char** survey, int surveyRowSize, int* choices) {
    int result[4] = {0};
    for (int i = 0; i < surveyRowSize; i++) {
        if (choices[i] < 4) {
            if (survey[i][0] == 'R') result[0] += 4 - choices[i];
            else if (survey[i][0] == 'C') result[1] += 4 - choices[i];
            else if (survey[i][0] == 'J') result[2] += 4 - choices[i];
            else if (survey[i][0] == 'A') result[3] += 4 - choices[i];
        } else {
            if (survey[i][1] == 'R') result[0] += choices[i] - 4;
            else if (survey[i][1] == 'C') result[1] += choices[i] - 4;
            else if (survey[i][1] == 'J') result[2] += choices[i] - 4;
            else if (survey[i][1] == 'A') result[3] += choices[i] - 4;
        }
    }

    char* answer = (char*)malloc(5 * sizeof(char));
    answer[0] = result[0] >= result[1] ? 'R' : 'C';
    answer[1] = result[2] >= result[3] ? 'F' : 'M';
    answer[2] = result[2] >= result[3] ? 'J' : 'M';
    answer[3] = result[0] >= result[1] ? 'T' : 'N';
    answer[4]='\0';

    return answer;
}
