#include <stdlib.h>

int cmp(const void *a, const void *b) {
    return *(int *)a - *(int *)b;
}

int solution(int *scoville, int scoville_len, int K) {
    int num_foods = scoville_len;
    qsort(scoville, scoville_len, sizeof(int), cmp);
    int score = scoville[0];

    int idx = 0;
    while (idx < num_foods - 1 && score < K) {
        scoville[0] = score + scoville[1] * 2;
        for (int i = 1; i < scoville_len - 1; i++) {
            scoville[i] = scoville[i + 1];
        }
        scoville_len--;
        qsort(scoville, scoville_len, sizeof(int), cmp);
        score = scoville[0];
        idx++;
    }

    return score < K ? -1 : idx;
}
