#include <stdlib.h>

int cmp(const void *a, const void *b) {
    return *(int *)b - *(int *)a;
}

long long solution(int n, int *works, int works_len) {
    for (int i = 0; i < works_len; i++) {
        works[i] = -works[i];
    }
    qsort(works, works_len, sizeof(int), cmp);

    for (int i = 0; i < n; i++) {
        int work = works[0];
        if (work == 0) {
            works[0] = work;
            break;
        }
        works[0] = work + 1;
        qsort(works, works_len, sizeof(int), cmp);
    }

    long long result = 0;
    for (int i = 0; i < works_len; i++) {
        result += (long long)works[i] * works[i];
    }
    return result;
}
