typedef struct {
    int value;
    int idx;
} Item;

int solution(int *numbers, int numbers_len, int target) {
    int result = 0;
    Item queue[1000000];
    int head = 0;
    int tail = 0;
    queue[tail++] = (Item){numbers[0], 0};
    queue[tail++] = (Item){-numbers[0], 0};

    while (head < tail) {
        Item item = queue[head++];
        int value = item.value;
        int idx = item.idx;
        if (idx == numbers_len - 1) {
            if (value == target) {
                result++;
            }
        } else {
            idx++;
            queue[tail++] = (Item){value + numbers[idx], idx};
            queue[tail++] = (Item){value - numbers[idx], idx};
        }
    }
    return result;
}
