#include <stdio.h>

int solution(int capacity, int num_stops, int *deliveries, int deliveriesSize, int *pickups, int pickupsSize) {
    int total_distance = 0;
    int current_deliveries = 0;
    int current_pickups = 0;
    int last_stop = num_stops - 1;

    for (int stop = num_stops - 1; stop >= 0; stop--) {
        current_deliveries += deliveries[stop];
        current_pickups += pickups[stop];

        while (current_deliveries > capacity || current_pickups > capacity) {
            current_deliveries -= capacity;
            current_pickups -= capacity;
            total_distance += 2 * (last_stop + 1);
            last_stop = stop;
        }
    }

    if (current_deliveries > 0 || current_pickups > 0) {
        total_distance += 2 * (last_stop + 1);
    }

    return total_distance;
}
