#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#define MAX_SIZE 3200000

typedef struct {
    int *array;
    int size;
} Array;

Array *newArray() {
    Array *array = malloc(sizeof(Array));
    array->array = malloc(MAX_SIZE * sizeof(int));
    array->size = 0;
    return array;
}

void add(Array *array, int value) {
    array->array[array->size++] = value;
}

bool contains(Array *array, int value) {
    for (int i = 0; i < array->size; i++) {
        if (array->array[i] == value) {
            return true;
        }
    }
    return false;
}

int inclination(int point1[], int point2[]) {
    return (point2[1] - point1[1]) / (point2[0] - point1[0]);
}

int solution(int **dots, int size) {
    Array *inclinations = newArray();
    for (int i = 0; i < size; i++) {
        for (int j = i + 1; j < size; j++) {
            int incl = inclination(dots[i], dots[j]);
            if (!contains(inclinations, incl)) {
                add(inclinations, incl);
            }
        }
    }

    return inclinations->size == 1 ? 1 : 0;
}
