#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int *solution(char **park, int parkSize, char **routes, int routesSize) {
    int w = parkSize;
    int h = strlen(park[0]);
    int y, x;
    for (int i = 0; i < w; i++) {
        for (int j = 0; j < h; j++) {
            if (park[i][j] == 'S') {
                y = i;
                x = j;
                break;
            }
        }
    }

    int navi[4][2] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
    for (int i = 0; i < routesSize; i++) {
        char *route = routes[i];
        char direction = route[0];
        int steps = atoi(route + 2);

        int dir_x, dir_y;
        switch (direction) {
            case 'E':
                dir_x = navi[0][0];
                dir_y = navi[0][1];
                break;
            case 'W':
                dir_x = navi[1][0];
                dir_y = navi[1][1];
                break;
            case 'S':
                dir_x = navi[2][0];
                dir_y = navi[2][1];
                break;
            default:
                dir_x = navi[3][0];
                dir_y = navi[3][1];
                break;
        }

        if (!(x + dir_x * steps >= 0 && x + dir_x * steps < h && y + dir_y * steps >= 0 && y + dir_y * steps < w)) {
            continue;
        }

        int block = 0;
        for (int step = 1; step <= steps; step++) {
            if (park[y + dir_y * step][x + dir_x * step] == 'X') {
                block = 1;
                break;
            }
        }

        if (!block) {
            x += dir_x * steps;
            y += dir_y * steps;
        }
    }

    int *result = malloc(2 * sizeof(int));
    result[0] = y;
    result[1] = x;

    return result;
}
