#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int to_days(char *date) {
    int year = atoi(strtok(date, "."));
    int month = atoi(strtok(NULL, "."));
    int day = atoi(strtok(NULL, "."));
    return year * 28 * 12 + month * 28 + day;
}

int *solution(char *today, char **terms, int termsSize, char **privacies, int privaciesSize) {
    int months[26];
    for (int i = 0; i < termsSize; i++) {
        char *term = terms[i];
        months[term[0] - 'A'] = atoi(term + 2) * 28;
    }

    int today_days = to_days(today);
    int *expire = malloc(privaciesSize * sizeof(int));
    int size = 0;
    for (int i = 0; i < privaciesSize; i++) {
        char *privacy = privacies[i];
        if (to_days(strtok(privacy, " ")) + months[strtok(NULL, " ")[0] - 'A'] <= today_days) {
            expire[size++] = i + 1;
        }
    }

    return expire;
}
