import java.util.HashMap;

public class Solution {
    public static String solution(String[] participant, String[] completion) {
        HashMap<String, Integer> completes = new HashMap<>();
        for (String name : completion) {
            completes.put(name, completes.getOrDefault(name, 0) + 1);
        }
        for (String name : participant) {
            if (completes.containsKey(name) && completes.get(name) > 0) {
                completes.put(name, completes.get(name) - 1);
            } else {
                return name;
            }
        }
        return "";
    }
}
