import java.util.ArrayList;
import java.util.HashMap;

public class Solution {
    public static String solution(String s, String skip, int index) {
        ArrayList<Character> aToZ = new ArrayList<>();
        for (char c : "abcdefghijklmnopqrstuvwxyz".toCharArray()) {
            if (!skip.contains(String.valueOf(c))) {
                aToZ.add(c);
            }
        }
        int l = aToZ.size();

        HashMap<Character, Integer> dicAlpha = new HashMap<>();
        for (int idx = 0; idx < l; idx++) {
            dicAlpha.put(aToZ.get(idx), idx);
        }

        StringBuilder result = new StringBuilder();
        for (char c : s.toCharArray()) {
            result.append(aToZ.get((dicAlpha.get(c) + index) % l));
        }

        return result.toString();
    }
}
