import java.util.*;

public class Solution {
    public static int solution(int[] priorities, int location) {
        Queue<int[]> queue = new LinkedList<>();
        for (int i = 0; i < priorities.length; i++) {
            queue.add(new int[]{i, priorities[i]});
        }
        int order = 0;
        while (!queue.isEmpty()) {
            int[] cur = queue.poll();
            boolean anyGreater = false;
            for (int[] q : queue) {
                if (cur[1] < q[1]) {
                    anyGreater = true;
                    break;
                }
            }
            if (anyGreater) {
                queue.add(cur);
            } else {
                order++;
                if (cur[0] == location) {
                    return order;
                }
            }
        }
        return -1;
    }
}
