public class Solution {
    public static int[] solution(char[][] wall) {
        int min_x = Integer.MAX_VALUE;
        int min_y = Integer.MAX_VALUE;
        int max_x = Integer.MIN_VALUE;
        int max_y = Integer.MIN_VALUE;
        for (int i = 0; i < wall.length; i++) {
            for (int j = 0; j < wall[i].length; j++) {
                if (wall[i][j] == '#') {
                    if (i < min_x) min_x = i;
                    if (j < min_y) min_y = j;
                    if (i > max_x) max_x = i;
                    if (j > max_y) max_y = j;
                }
            }
        }
        return new int[]{min_x, min_y, max_x + 1, max_y + 1};
    }
}
