import java.util.Arrays;
import java.util.HashMap;

public class Solution {
    public static int[] solution(String s) {
        int[] answer = new int[s.length()];
        Arrays.fill(answer, -1);
        HashMap<Character, Integer> order = new HashMap<>();
        for (int idx = 0; idx < s.length(); idx++) {
            char char_ = s.charAt(idx);
            if (order.containsKey(char_)) {
                answer[idx] = idx - order.get(char_);
            }
            order.put(char_, idx);
        }
        return answer;
    }
}
