import java.util.*;

public class Solution {
    public static int[] solution(int k, int[] score) {
        int[] answer = new int[score.length];
        Queue<Integer> rank = new PriorityQueue<>();
        for (int i = 0; i < score.length; i++) {
            int sco = score[i];
            rank.add(sco);
            if (rank.size() > k) {
                rank.poll();
            }
            answer[i] = rank.peek();
        }
        return answer;
    }
}
