import java.util.*;

public class Solution {
    public static String[] solution(String[][] tickets) {
        Map<String,List<String>> routes = new HashMap<>();
        for (String[] ticket : tickets) {
            String key = ticket[0];
            String value = ticket[1];
            if (!routes.containsKey(key)) {
                routes.put(key,new ArrayList<>());
            }
            routes.get(key).add(value);
        }

        for (List<String> value : routes.values()) {
            Collections.sort(value);
        }

        Stack<String> stack = new Stack<>();
        stack.push("ICN");
        List<String> pathList = new ArrayList<>();
        while (!stack.empty()) {
            String top = stack.peek();
            if (!routes.containsKey(top) || routes.get(top).isEmpty()) {
                pathList.add(stack.pop());
            } else {
                stack.push(routes.get(top).remove(0));
            }
        }

        Collections.reverse(pathList);
        String[] path = new String[pathList.size()];
        for (int i=0; i<pathList.size(); i++) {
            path[i]=pathList.get(i);
        }
        
        return path;
    }
}
