import java.util.*;

public class Solution {
    public static int solution(int n, int[][] computers) {
        int[] visited = new int[n];
        int networks = 0;

        for (int node = 0; node < n; node++) {
            if (visited[node] == 0) {
                Stack<Integer> stack = new Stack<>();
                stack.push(node);
                visited[node] = 1;

                while (!stack.empty()) {
                    int curr = stack.pop();

                    for (int nextNode = 0; nextNode < n; nextNode++) {
                        if (visited[nextNode] == 0 && computers[curr][nextNode] == 1) {
                            visited[nextNode] = 1;
                            stack.push(nextNode);
                        }
                    }
                }

                networks++;
            }
        }

        return networks;
    }
}
