import java.util.*;

public class Solution {
    public static int solution(int[] numbers, int target) {
        int result = 0;
        Queue<int[]> queue = new LinkedList<>();
        queue.add(new int[]{numbers[0], 0});
        queue.add(new int[]{-numbers[0], 0});

        while (!queue.isEmpty()) {
            int[] item = queue.poll();
            int value = item[0];
            int idx = item[1];
            if (idx == numbers.length - 1) {
                if (value == target) {
                    result++;
                }
            } else {
                idx++;
                queue.add(new int[]{value + numbers[idx], idx});
                queue.add(new int[]{value - numbers[idx], idx});
            }
        }
        return result;
    }
}
