import java.util.*;

public class Solution {
    static class Command {
        public final int i;
        public final int j;
        public final int k;

        public Command(int i, int j, int k) {
            this.i = i;
            this.j = j;
            this.k = k;
        }
    }

    public static int[] solution(int[] array, Command[] commands) {
        final var result = new int[commands.length];
        for (int i = 0; i < commands.length; i++) {
            final var command = commands[i];
            final var i_ = command.i - 1;
            final var j_ = command.j - 1;
            final var k_ = command.k - 1;

            final var temp = Arrays.copyOfRange(array, i_, j_ + 1);
            Arrays.sort(temp);
            result[i] = temp[k_];
        }
        return result;
    }
}
