import java.util.HashSet;

public class Solution {
    public static int solution(int n, int[] lost, int[] reserve) {
        HashSet<Integer> reserveSet = new HashSet<>();
        HashSet<Integer> lostSet = new HashSet<>();
        for (int res : reserve) {
            reserveSet.add(res);
        }
        for (int los : lost) {
            lostSet.add(los);
        }

        reserveSet.removeAll(lostSet);
        lostSet.removeAll(reserveSet);

        for (int res : reserve) {
            if (lostSet.contains(res - 1)) {
                lostSet.remove(res - 1);
            } else if (lostSet.contains(res + 1)) {
                lostSet.remove(res + 1);
            }
        }

        return n - lostSet.size();
    }
}
