public class Solution {
    public static boolean is_safe(int x, int y, int width, int height) {
        return -width <= x && x <= width && -height <= y && y <= height;
    }

    public static int[] solution(String[] keyinput, int[] board) {
        int width = board[0] / 2;
        int height = board[1] / 2;
        int[] pos = {0, 0};

        for (String key : keyinput) {
            int[] move;
            switch (key) {
                case "up":
                    move = new int[]{0, 1};
                    break;
                case "down":
                    move = new int[]{0, -1};
                    break;
                case "right":
                    move = new int[]{1, 0};
                    break;
                default:
                    move = new int[]{-1, 0};
                    break;
            }

            if (is_safe(pos[0] + move[0], pos[1] + move[1], width, height)) {
                pos[0] += move[0];
                pos[1] += move[1];
            }
        }

        return pos;
    }
}
