public class Solution {
    public static int[] solution(String[] park, String[] routes) {
        int w = park.length;
        int h = park[0].length();
        int y = 0, x = 0;
        for (int i = 0; i < w; i++) {
            if (park[i].contains("S")) {
                y = i;
                x = park[i].indexOf("S");
                break;
            }
        }

        int[][] navi = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
        for (String route : routes) {
            String[] splitRoute = route.split(" ");
            String directionStr = splitRoute[0];
            char directionChar = directionStr.charAt(0);
            int steps = Integer.parseInt(splitRoute[1]);

            int dir_x, dir_y;
            switch (directionChar) {
                case 'E':
                    dir_x = navi[0][0];
                    dir_y = navi[0][1];
                    break;
                case 'W':
                    dir_x = navi[1][0];
                    dir_y = navi[1][1];
                    break;
                case 'S':
                    dir_x = navi[2][0];
                    dir_y = navi[2][1];
                    break;
                default:
                    dir_x = navi[3][0];
                    dir_y = navi[3][1];
                    break;
            }

            if (!(x + dir_x * steps >= 0 && x + dir_x * steps < h && y + dir_y * steps >= 0 && y + dir_y * steps < w)) {
                continue;
            }

            boolean block = false;
            for (int step = 1; step <= steps; step++) {
                if (park[y + dir_y * step].charAt(x + dir_x * step) == 'X') {
                    block = true;
                    break;
                }
            }

            if (!block) {
                x += dir_x * steps;
                y += dir_y * steps;
            }
        }

        return new int[]{y, x};
    }
}
