public class Solution {
    public static String solution(int[] numbers, String hand) {
        StringBuilder answer = new StringBuilder();

        int[] left = {3, 2, 1};
        int[] right = {3, 2, 1};
        int[] center = {3, 2, 1, 0};

        int[] left_pos = {0, 0};
        int[] right_pos = {2, 0};

        for (int number : numbers) {
            if (number == 1 || number == 4 || number == 7) {
                answer.append('L');
                left_pos[0] = 0;
                left_pos[1] = left[number / 3];
            } else if (number == 3 || number == 6 || number == 9) {
                answer.append('R');
                right_pos[0] = 2;
                right_pos[1] = right[number / 3 - 1];
            } else {
                int left_dist =
                        Math.abs(1 - left_pos[0]) + Math.abs(left_pos[1] - center[number / 3]);
                int right_dist =
                        Math.abs(right_pos[0] - 1) + Math.abs(right_pos[1] - center[number / 3]);

                if (left_dist < right_dist) {
                    answer.append('L');
                    left_pos[0] = 1;
                    left_pos[1] = center[number / 3];
                } else if (left_dist > right_dist) {
                    answer.append('R');
                    right_pos[0] = 1;
                    right_pos[1] = center[number / 3];
                } else {
                    if (hand.equals("left")) {
                        answer.append('L');
                        left_pos[0] = 1;
                        left_pos[1] = center[number / 3];
                    } else {
                        answer.append('R');
                        right_pos[0] = 1;
                        right_pos[1] = center[number /